import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BlockstorageVolumeAttachV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#attach_mode BlockstorageVolumeAttachV2#attach_mode}
    */
    readonly attachMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#device BlockstorageVolumeAttachV2#device}
    */
    readonly device?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#host_name BlockstorageVolumeAttachV2#host_name}
    */
    readonly hostName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#id BlockstorageVolumeAttachV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#initiator BlockstorageVolumeAttachV2#initiator}
    */
    readonly initiator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#instance_id BlockstorageVolumeAttachV2#instance_id}
    */
    readonly instanceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#ip_address BlockstorageVolumeAttachV2#ip_address}
    */
    readonly ipAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#multipath BlockstorageVolumeAttachV2#multipath}
    */
    readonly multipath?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#os_type BlockstorageVolumeAttachV2#os_type}
    */
    readonly osType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#platform BlockstorageVolumeAttachV2#platform}
    */
    readonly platform?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#region BlockstorageVolumeAttachV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#volume_id BlockstorageVolumeAttachV2#volume_id}
    */
    readonly volumeId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#wwnn BlockstorageVolumeAttachV2#wwnn}
    */
    readonly wwnn?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#wwpn BlockstorageVolumeAttachV2#wwpn}
    */
    readonly wwpn?: string[];
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#timeouts BlockstorageVolumeAttachV2#timeouts}
    */
    readonly timeouts?: BlockstorageVolumeAttachV2Timeouts;
}
export interface BlockstorageVolumeAttachV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#create BlockstorageVolumeAttachV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#delete BlockstorageVolumeAttachV2#delete}
    */
    readonly delete?: string;
}
export declare function blockstorageVolumeAttachV2TimeoutsToTerraform(struct?: BlockstorageVolumeAttachV2Timeouts | cdktf.IResolvable): any;
export declare function blockstorageVolumeAttachV2TimeoutsToHclTerraform(struct?: BlockstorageVolumeAttachV2Timeouts | cdktf.IResolvable): any;
export declare class BlockstorageVolumeAttachV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): BlockstorageVolumeAttachV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: BlockstorageVolumeAttachV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2 openstack_blockstorage_volume_attach_v2}
*/
export declare class BlockstorageVolumeAttachV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_blockstorage_volume_attach_v2";
    /**
    * Generates CDKTF code for importing a BlockstorageVolumeAttachV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BlockstorageVolumeAttachV2 to import
    * @param importFromId The id of the existing BlockstorageVolumeAttachV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BlockstorageVolumeAttachV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_attach_v2 openstack_blockstorage_volume_attach_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BlockstorageVolumeAttachV2Config
    */
    constructor(scope: Construct, id: string, config: BlockstorageVolumeAttachV2Config);
    private _attachMode?;
    get attachMode(): string;
    set attachMode(value: string);
    resetAttachMode(): void;
    get attachModeInput(): string | undefined;
    private _data;
    get data(): cdktf.StringMap;
    private _device?;
    get device(): string;
    set device(value: string);
    resetDevice(): void;
    get deviceInput(): string | undefined;
    get driverVolumeType(): string;
    private _hostName?;
    get hostName(): string;
    set hostName(value: string);
    get hostNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _initiator?;
    get initiator(): string;
    set initiator(value: string);
    resetInitiator(): void;
    get initiatorInput(): string | undefined;
    private _instanceId?;
    get instanceId(): string;
    set instanceId(value: string);
    resetInstanceId(): void;
    get instanceIdInput(): string | undefined;
    private _ipAddress?;
    get ipAddress(): string;
    set ipAddress(value: string);
    resetIpAddress(): void;
    get ipAddressInput(): string | undefined;
    get mountPointBase(): string;
    private _multipath?;
    get multipath(): boolean | cdktf.IResolvable;
    set multipath(value: boolean | cdktf.IResolvable);
    resetMultipath(): void;
    get multipathInput(): boolean | cdktf.IResolvable | undefined;
    private _osType?;
    get osType(): string;
    set osType(value: string);
    resetOsType(): void;
    get osTypeInput(): string | undefined;
    private _platform?;
    get platform(): string;
    set platform(value: string);
    resetPlatform(): void;
    get platformInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _volumeId?;
    get volumeId(): string;
    set volumeId(value: string);
    get volumeIdInput(): string | undefined;
    private _wwnn?;
    get wwnn(): string;
    set wwnn(value: string);
    resetWwnn(): void;
    get wwnnInput(): string | undefined;
    private _wwpn?;
    get wwpn(): string[];
    set wwpn(value: string[]);
    resetWwpn(): void;
    get wwpnInput(): string[] | undefined;
    private _timeouts;
    get timeouts(): BlockstorageVolumeAttachV2TimeoutsOutputReference;
    putTimeouts(value: BlockstorageVolumeAttachV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | BlockstorageVolumeAttachV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
