import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BlockstorageVolumeV2Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#availability_zone BlockstorageVolumeV2#availability_zone}
    */
    readonly availabilityZone?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#consistency_group_id BlockstorageVolumeV2#consistency_group_id}
    */
    readonly consistencyGroupId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#description BlockstorageVolumeV2#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#id BlockstorageVolumeV2#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#image_id BlockstorageVolumeV2#image_id}
    */
    readonly imageId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#metadata BlockstorageVolumeV2#metadata}
    */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#name BlockstorageVolumeV2#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#region BlockstorageVolumeV2#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#size BlockstorageVolumeV2#size}
    */
    readonly size: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#snapshot_id BlockstorageVolumeV2#snapshot_id}
    */
    readonly snapshotId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#source_replica BlockstorageVolumeV2#source_replica}
    */
    readonly sourceReplica?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#source_vol_id BlockstorageVolumeV2#source_vol_id}
    */
    readonly sourceVolId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#volume_type BlockstorageVolumeV2#volume_type}
    */
    readonly volumeType?: string;
    /**
    * scheduler_hints block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#scheduler_hints BlockstorageVolumeV2#scheduler_hints}
    */
    readonly schedulerHints?: BlockstorageVolumeV2SchedulerHints[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#timeouts BlockstorageVolumeV2#timeouts}
    */
    readonly timeouts?: BlockstorageVolumeV2Timeouts;
}
export interface BlockstorageVolumeV2Attachment {
}
export declare function blockstorageVolumeV2AttachmentToTerraform(struct?: BlockstorageVolumeV2Attachment): any;
export declare function blockstorageVolumeV2AttachmentToHclTerraform(struct?: BlockstorageVolumeV2Attachment): any;
export declare class BlockstorageVolumeV2AttachmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): BlockstorageVolumeV2Attachment | undefined;
    set internalValue(value: BlockstorageVolumeV2Attachment | undefined);
    get device(): string;
    get id(): string;
    get instanceId(): string;
}
export declare class BlockstorageVolumeV2AttachmentList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): BlockstorageVolumeV2AttachmentOutputReference;
}
export interface BlockstorageVolumeV2SchedulerHints {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#additional_properties BlockstorageVolumeV2#additional_properties}
    */
    readonly additionalProperties?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#different_host BlockstorageVolumeV2#different_host}
    */
    readonly differentHost?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#local_to_instance BlockstorageVolumeV2#local_to_instance}
    */
    readonly localToInstance?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#query BlockstorageVolumeV2#query}
    */
    readonly query?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#same_host BlockstorageVolumeV2#same_host}
    */
    readonly sameHost?: string[];
}
export declare function blockstorageVolumeV2SchedulerHintsToTerraform(struct?: BlockstorageVolumeV2SchedulerHints | cdktf.IResolvable): any;
export declare function blockstorageVolumeV2SchedulerHintsToHclTerraform(struct?: BlockstorageVolumeV2SchedulerHints | cdktf.IResolvable): any;
export declare class BlockstorageVolumeV2SchedulerHintsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): BlockstorageVolumeV2SchedulerHints | cdktf.IResolvable | undefined;
    set internalValue(value: BlockstorageVolumeV2SchedulerHints | cdktf.IResolvable | undefined);
    private _additionalProperties?;
    get additionalProperties(): {
        [key: string]: string;
    };
    set additionalProperties(value: {
        [key: string]: string;
    });
    resetAdditionalProperties(): void;
    get additionalPropertiesInput(): {
        [key: string]: string;
    } | undefined;
    private _differentHost?;
    get differentHost(): string[];
    set differentHost(value: string[]);
    resetDifferentHost(): void;
    get differentHostInput(): string[] | undefined;
    private _localToInstance?;
    get localToInstance(): string;
    set localToInstance(value: string);
    resetLocalToInstance(): void;
    get localToInstanceInput(): string | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    resetQuery(): void;
    get queryInput(): string | undefined;
    private _sameHost?;
    get sameHost(): string[];
    set sameHost(value: string[]);
    resetSameHost(): void;
    get sameHostInput(): string[] | undefined;
}
export declare class BlockstorageVolumeV2SchedulerHintsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: BlockstorageVolumeV2SchedulerHints[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): BlockstorageVolumeV2SchedulerHintsOutputReference;
}
export interface BlockstorageVolumeV2Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#create BlockstorageVolumeV2#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#delete BlockstorageVolumeV2#delete}
    */
    readonly delete?: string;
}
export declare function blockstorageVolumeV2TimeoutsToTerraform(struct?: BlockstorageVolumeV2Timeouts | cdktf.IResolvable): any;
export declare function blockstorageVolumeV2TimeoutsToHclTerraform(struct?: BlockstorageVolumeV2Timeouts | cdktf.IResolvable): any;
export declare class BlockstorageVolumeV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): BlockstorageVolumeV2Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: BlockstorageVolumeV2Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2 openstack_blockstorage_volume_v2}
*/
export declare class BlockstorageVolumeV2 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_blockstorage_volume_v2";
    /**
    * Generates CDKTF code for importing a BlockstorageVolumeV2 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BlockstorageVolumeV2 to import
    * @param importFromId The id of the existing BlockstorageVolumeV2 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BlockstorageVolumeV2 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/blockstorage_volume_v2 openstack_blockstorage_volume_v2} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BlockstorageVolumeV2Config
    */
    constructor(scope: Construct, id: string, config: BlockstorageVolumeV2Config);
    private _attachment;
    get attachment(): BlockstorageVolumeV2AttachmentList;
    private _availabilityZone?;
    get availabilityZone(): string;
    set availabilityZone(value: string);
    resetAvailabilityZone(): void;
    get availabilityZoneInput(): string | undefined;
    private _consistencyGroupId?;
    get consistencyGroupId(): string;
    set consistencyGroupId(value: string);
    resetConsistencyGroupId(): void;
    get consistencyGroupIdInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _imageId?;
    get imageId(): string;
    set imageId(value: string);
    resetImageId(): void;
    get imageIdInput(): string | undefined;
    private _metadata?;
    get metadata(): {
        [key: string]: string;
    };
    set metadata(value: {
        [key: string]: string;
    });
    resetMetadata(): void;
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _size?;
    get size(): number;
    set size(value: number);
    get sizeInput(): number | undefined;
    private _snapshotId?;
    get snapshotId(): string;
    set snapshotId(value: string);
    resetSnapshotId(): void;
    get snapshotIdInput(): string | undefined;
    private _sourceReplica?;
    get sourceReplica(): string;
    set sourceReplica(value: string);
    resetSourceReplica(): void;
    get sourceReplicaInput(): string | undefined;
    private _sourceVolId?;
    get sourceVolId(): string;
    set sourceVolId(value: string);
    resetSourceVolId(): void;
    get sourceVolIdInput(): string | undefined;
    private _volumeType?;
    get volumeType(): string;
    set volumeType(value: string);
    resetVolumeType(): void;
    get volumeTypeInput(): string | undefined;
    private _schedulerHints;
    get schedulerHints(): BlockstorageVolumeV2SchedulerHintsList;
    putSchedulerHints(value: BlockstorageVolumeV2SchedulerHints[] | cdktf.IResolvable): void;
    resetSchedulerHints(): void;
    get schedulerHintsInput(): cdktf.IResolvable | BlockstorageVolumeV2SchedulerHints[] | undefined;
    private _timeouts;
    get timeouts(): BlockstorageVolumeV2TimeoutsOutputReference;
    putTimeouts(value: BlockstorageVolumeV2Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | BlockstorageVolumeV2Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
