import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LbPoolV1Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#id LbPoolV1#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#lb_method LbPoolV1#lb_method}
    */
    readonly lbMethod: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#lb_provider LbPoolV1#lb_provider}
    */
    readonly lbProvider?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#member LbPoolV1#member}
    */
    readonly member?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#monitor_ids LbPoolV1#monitor_ids}
    */
    readonly monitorIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#name LbPoolV1#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#protocol LbPoolV1#protocol}
    */
    readonly protocol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#region LbPoolV1#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#subnet_id LbPoolV1#subnet_id}
    */
    readonly subnetId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#tenant_id LbPoolV1#tenant_id}
    */
    readonly tenantId?: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#timeouts LbPoolV1#timeouts}
    */
    readonly timeouts?: LbPoolV1Timeouts;
}
export interface LbPoolV1Timeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#create LbPoolV1#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#delete LbPoolV1#delete}
    */
    readonly delete?: string;
}
export declare function lbPoolV1TimeoutsToTerraform(struct?: LbPoolV1Timeouts | cdktf.IResolvable): any;
export declare function lbPoolV1TimeoutsToHclTerraform(struct?: LbPoolV1Timeouts | cdktf.IResolvable): any;
export declare class LbPoolV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbPoolV1Timeouts | cdktf.IResolvable | undefined;
    set internalValue(value: LbPoolV1Timeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1 openstack_lb_pool_v1}
*/
export declare class LbPoolV1 extends cdktf.TerraformResource {
    static readonly tfResourceType = "openstack_lb_pool_v1";
    /**
    * Generates CDKTF code for importing a LbPoolV1 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the LbPoolV1 to import
    * @param importFromId The id of the existing LbPoolV1 that should be imported. Refer to the {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the LbPoolV1 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/terraform-provider-openstack/openstack/1.54.1/docs/resources/lb_pool_v1 openstack_lb_pool_v1} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LbPoolV1Config
    */
    constructor(scope: Construct, id: string, config: LbPoolV1Config);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _lbMethod?;
    get lbMethod(): string;
    set lbMethod(value: string);
    get lbMethodInput(): string | undefined;
    private _lbProvider?;
    get lbProvider(): string;
    set lbProvider(value: string);
    resetLbProvider(): void;
    get lbProviderInput(): string | undefined;
    private _member?;
    get member(): string[];
    set member(value: string[]);
    resetMember(): void;
    get memberInput(): string[] | undefined;
    private _monitorIds?;
    get monitorIds(): string[];
    set monitorIds(value: string[]);
    resetMonitorIds(): void;
    get monitorIdsInput(): string[] | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    get protocolInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    get subnetIdInput(): string | undefined;
    private _tenantId?;
    get tenantId(): string;
    set tenantId(value: string);
    resetTenantId(): void;
    get tenantIdInput(): string | undefined;
    private _timeouts;
    get timeouts(): LbPoolV1TimeoutsOutputReference;
    putTimeouts(value: LbPoolV1Timeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | LbPoolV1Timeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
